import java.util.Deque;
import java.util.LinkedList;

public class Position {

	LinkedList<Integer> mpXArray;
	LinkedList<Integer> mpYArray;
	LinkedList<Integer> opXArray;
	LinkedList<Integer> opYArray;
	int memoryFrame;

	Position(int memoryFrame, boolean player) {
		// current frame + previous frames
		this.memoryFrame = memoryFrame + 1;

		mpXArray = new LinkedList<Integer>();
		mpYArray = new LinkedList<Integer>();
		opXArray = new LinkedList<Integer>();
		opYArray = new LinkedList<Integer>();

		if (player) {
			for (int i = 0; i < this.memoryFrame; i++) {

				mpXArray.addFirst(125);
				opXArray.addFirst(580);
				mpYArray.addFirst(320);
				opYArray.addFirst(320);
			}
		} else {
			for (int i = 0; i < this.memoryFrame; i++) {

				mpXArray.addFirst(580);
				opXArray.addFirst(125);
				mpYArray.addFirst(320);
				opYArray.addFirst(320);
			}
		}

	}

	void update(int newPos[]) {
		if (newPos.length != 4) {
			System.out.println("size error");
		}

		mpXArray.addFirst(newPos[0]);
		mpYArray.addFirst(newPos[1]);
		opXArray.addFirst(newPos[2]);
		opYArray.addFirst(newPos[3]);
		mpXArray.removeLast();
		opXArray.removeLast();
		mpYArray.removeLast();
		opYArray.removeLast();

	}

	// boolean checksize() {
	// if (mpXArray.size() == memoryFrame && mpYArray.size() == memoryFrame
	// && opXArray.size() == memoryFrame
	// && opYArray.size() == memoryFrame) {
	// return true;
	// } else {
	// return false;
	// }
	// }

	int[] LEP(int predFrame) {
		// if (predFrame > memoryFrame) {
		// System.out.println("Unexpedted FrameNumber");
		// return new int[4];
		// }

		int[] result = new int[4];
		result[0] = mpXArray.getFirst() * 2 - mpXArray.get(predFrame);
		result[1] = mpYArray.getFirst() * 2 - mpYArray.get(predFrame);
		result[2] = opXArray.getFirst() * 2 - opXArray.get(predFrame);
		result[3] = opYArray.getFirst() * 2 - opYArray.get(predFrame);

		if (result[1] > 335) {
			result[1] = 335;
		}
		if (result[3] > 335) {
			result[3] = 335;
		}

		return result;
	}

	double[] getNumNow(int myR, int myL, int opR, int opL) {
		int NowRelX = Math.abs(mpXArray.getFirst() - opXArray.getFirst()
				+ (opR - opL + myR - myL));
		int NowRelXdif = NowRelX
				- Math.abs((mpXArray).get(15) - (opXArray).get(15)
						+ (opR - opL + myR - myL));
		int NowRelY = mpYArray.getFirst() - opYArray.getFirst();
		int NowRelYdif = NowRelY - (mpYArray.get(15) - opYArray.get(15));
		int NowAbsY = opYArray.getFirst();
		int NowAbsYdif = opYArray.getFirst() - (opYArray).get(15);
		double numNow[] = { NowRelX, NowRelXdif, NowRelY, NowRelYdif, NowAbsY,
				NowAbsYdif };

		return numNow;
	}

	double[] getNumkNN(int myR, int myL, int opR, int opL) {

		int kNNRelX = Math.abs(mpXArray.get(15) - opXArray.get(15)
				+ (opR - opL + myR - myL));
		int kNNRelXdif = kNNRelX
				- Math.abs(mpXArray.get(30) - opXArray.get(30)
						+ (opR - opL + myR - myL));
		int kNNRelY = mpYArray.get(15) - opYArray.get(15);
		int kNNRelYdif = kNNRelY - (mpYArray.get(30) - opYArray.get(30));
		int kNNAbsY = opYArray.get(15);
		int kNNAbsYdif = kNNAbsY - opYArray.get(30);

		double[] numkNN = { kNNRelX, kNNRelXdif, kNNRelY, kNNRelYdif, kNNAbsY,
				kNNAbsYdif };
		return numkNN;
	}

	Deque<Integer> getMpXArray() {
		return mpXArray;
	}

	Deque<Integer> getMpYArray() {
		return mpYArray;
	}

	Deque<Integer> getOpXArray() {
		return opXArray;
	}

	Deque<Integer> getOpYArray() {
		return opYArray;
	}

}
