import java.util.ArrayList;

public class kNearestNeighbor {
	int k;
	int numberOfNum;
	ArrayList<ArrayList<Object>> arrayout;

	public kNearestNeighbor(int k, int numberOfNum) {
		arrayout = new ArrayList<ArrayList<Object>>();
		this.k = k;
		this.numberOfNum = numberOfNum;
	}

	public boolean addPoint(double numData[], Object state) {
		ArrayList<Object> arrayin = new ArrayList<Object>();

		if (numData.length != numberOfNum) {
			return false;
		}

		for (double id : numData) {
			arrayin.add(id);
		}

		arrayin.add(state);

		arrayout.add(arrayin);

		return true;
	}

	public Object getAction(double num[]) {

		if (num.length != numberOfNum || arrayout.isEmpty()) {
			return null;
		}

		ArrayList<ArrayList<Object>> sortArray = new ArrayList<ArrayList<Object>>();

		for (int i = 0; i < arrayout.size(); i++) {

			double numData[] = new double[numberOfNum];
			for (int j = 0; j < numberOfNum; j++) {
				numData[j] = (double) arrayout.get(i).get(j);
			}
			double dist = euclideanDistance(num, numData);

			arrayout.get(i).add(dist);
		}

		for (int i = 0; i < arrayout.size(); i++) {

			if (sortArray.isEmpty()) {
				sortArray.add(arrayout.get(i));
				continue;
			}

			double d = (double) (arrayout.get(i).get(numberOfNum + 1));

			int j = 0;
			while (d > (double) sortArray.get(j).get(numberOfNum + 1)) {
				j++;
				if (sortArray.size() == j) {
					break;
				}
			}

			sortArray.add(j, arrayout.get(i));
			if (sortArray.size() > k) {
				sortArray.remove(k);
			}
		}

		for (int i = 0; i < arrayout.size(); i++) {
			arrayout.get(i).remove(numberOfNum + 1);
		}

		Object[] states = new Object[sortArray.size()];
		int ii = 0;
		for (ArrayList<Object> arrayList : sortArray) {
			states[ii] = arrayList.get(numberOfNum);
			ii++;
		}

		Object maxState = majority(states);

		return maxState;
	}

	public double euclideanDistance(double num1[], double num2[]) {

		if (num1.length != num2.length) {
			return -1;
		}

		double sumOfSquares = 0;

		for (int i = 0; i < num1.length; i++) {
			sumOfSquares += Math.pow((num1[i] - num2[i]), 2d);
		}

		return Math.sqrt(sumOfSquares);
	}

	public Object majority(Object[] states) {
		ArrayList<Integer> excludeIndex = new ArrayList<Integer>();
		ArrayList<Boolean> boolArray = new ArrayList<Boolean>();
		ArrayList<Object> maxNumberObjectArray = new ArrayList<Object>();
		int max = 0;
		Object maxNumberObject = new Object();

		for (int i = 0; i < states.length; i++) {
			if (excludeIndex.contains((Integer) i)) {
				continue;
			}
			int count = 0;
			for (int j = i + 1; j < states.length; j++) {

				boolean bool = states[i].equals(states[j]);
				boolArray.add(bool);
				if (bool) {
					excludeIndex.add((Integer) (j));
					count++;
				}

			}

			if (count > max) {
				maxNumberObjectArray.clear();
				max = count;
				maxNumberObject = states[i];
			} else if (count == max) {
				maxNumberObjectArray.add(states[i]);
			}
		}

		if (!maxNumberObjectArray.isEmpty()) {
			int index = (int) (Math.random() * maxNumberObjectArray.size());
			maxNumberObject = maxNumberObjectArray.get(index);
		}

		return maxNumberObject;

	}
}
